#include <iostream>
using namespace std;

int main()
{
    int n, q;
    cin >> n >> q;
    long long dan[n], kup[n];
    
    for(int i=0; i<n; i++)
    cin >> dan[i] >> kup[i];
    
    long long pit[q], odg[q] = {0};
    for(int j = 0; j < q; j++)
    cin >> pit[j];
    
    for(int j=0; j<q; j++)
	{
        int i = 0;
        while(i<n)
		{
            while(kup[i]>0 and dan[i]<=pit[j])
			{
                odg[j]++;
                kup[i]--;
                dan[i]++;
            }
            i++;
        }
    }
    for(int j=0; j<q; j++)
    cout << odg[j] << endl;
    return 0;
}